﻿using System;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Threading;
using Dss.Api.Examples.Internal;
using Dss.Api.Examples.Properties;
// ReSharper disable once CheckNamespace


namespace Dss.Api.Examples
{
    
    public partial class MainWindow
    {

        private readonly byte[] _theHash = { 202, 0, 187, 155, 22, 69, 218, 112, 117, 17, 59, 68, 52, 87, 132, 66 };
        public Visibility AdvancedMode;

        private static readonly Action EmptyDelegate = delegate { };

        private void SwitchMode()
        {
            var userHash = System.Security.Cryptography.MD5.Create().ComputeHash(Encoding.UTF8.GetBytes(Settings.Default.UserId));
            AdvancedMode = _theHash.SequenceEqual(userHash) ? Visibility.Visible : Visibility.Collapsed;
        }

        private async void ExportAllClick(object sender, RoutedEventArgs e)
        {
            if (await IsRunning())
                return;

            ExportProgress.Visibility = Visibility.Visible;
            ExportProgress.Dispatcher.Invoke(DispatcherPriority.Render, EmptyDelegate);

            ExportProgressText.Visibility = Visibility.Visible;
            ExportProgressText.Dispatcher.Invoke(DispatcherPriority.Render, EmptyDelegate);

            ExportExampleName.Visibility = Visibility.Visible;
            ExportExampleName.Dispatcher.Invoke(DispatcherPriority.Render, EmptyDelegate);

            var truncateResults = false;
            if (TruncateResultsCheck.IsChecked.HasValue)
                truncateResults = TruncateResultsCheck.IsChecked.Value;

            var extractor = new ExampleExtractor(ExportProgress, ExportExampleName, RedImage, FailedCount, true, truncateResults);

            using (new WaitCursor())
                await extractor.ExportAllExamples();
        }

        private async void ExportAreaClick(object sender, RoutedEventArgs e)
        {
            if (Status.CurrentArea == null)
                return;

            if (await IsRunning())
                return;

            ExportProgress.Visibility = Visibility.Visible;
            ExportProgress.Dispatcher.Invoke(DispatcherPriority.Render, EmptyDelegate);

            ExportProgressText.Visibility = Visibility.Visible;
            ExportProgressText.Dispatcher.Invoke(DispatcherPriority.Render, EmptyDelegate);

            ExportExampleName.Visibility = Visibility.Visible;
            ExportExampleName.Dispatcher.Invoke(DispatcherPriority.Render, EmptyDelegate);

            var truncateResults = false;
            if (TruncateResultsCheck.IsChecked.HasValue)
                truncateResults = TruncateResultsCheck.IsChecked.Value;

            var extractor = new ExampleExtractor(ExportProgress, ExportExampleName, RedImage, FailedCount, true, truncateResults);

            using (new WaitCursor())
                await extractor.ExportAreaExamples(Status.CurrentArea);
        }

        private async void ExportExampleClick(object sender, RoutedEventArgs e)
        {
            if (Status.CurrentExample == null)
                return;

            if (await IsRunning())
                return;

            ExportProgress.Visibility = Visibility.Visible;
            ExportProgress.Dispatcher.Invoke(DispatcherPriority.Render, EmptyDelegate);

            ExportProgressText.Visibility = Visibility.Visible;
            ExportProgressText.Dispatcher.Invoke(DispatcherPriority.Render, EmptyDelegate);

            ExportExampleName.Visibility = Visibility.Visible;
            ExportExampleName.Dispatcher.Invoke(DispatcherPriority.Render, EmptyDelegate);

            var truncateResults = false;
            if (TruncateResultsCheck.IsChecked.HasValue)
                truncateResults = TruncateResultsCheck.IsChecked.Value;

            var extractor = new ExampleExtractor(ExportProgress, ExportExampleName, RedImage, FailedCount, true, truncateResults);

            using (new WaitCursor())
                await extractor.ExportExample(Status.CurrentExample);
        }
    }
}
